      import { main } from "./main";
      import { createWorldObjects } from "./world";
      import * as THREE from "three";
      import { CSS3DRenderer } from "three/examples/jsm/renderers/CSS3DRenderer.js";
      import { CSS3DObject } from "three/examples/jsm/renderers/CSS3DRenderer.js";
      import { CSS3DSprite } from "three/examples/jsm/renderers/CSS3DRenderer.js";
      import { TransformControls } from 'three/examples/jsm/controls/TransformControls.js';
      import { OrbitControls } from 'three/examples/jsm/controls/OrbitControls.js';
      import { FirstPersonControls } from 'three/examples/jsm/controls/FirstPersonControls.js';
      import { GLTFLoader } from 'three/examples/jsm/loaders/GLTFLoader.js';
      import { FBXLoader } from "three/examples/jsm/loaders/FBXLoader.js";
      import { AnimationClipCreator } from "three/examples/jsm/animation/AnimationClipCreator.js";

      import { P2P_Connection
      ,P2P_Client 
      ,pack_transform
      ,unpack_transform
      } from "p2p-client";
      import { 
      alertAsync
      ,confirmAsync 
      ,choiceAsync
      ,promptAsync
      ,sliderAsync
      } from "./dialogUtil";
      import { 
      loadModel
      ,loadModelFromArrayBuffer
      ,loadPlyFromText
      ,makePlyGeometryFromText
      } from "./modelUtil";

      import { 
      AVATARS
      ,ANIMATION_MAP
      ,dic_ANIMATION_NAME
      ,dic_nonloop_animation
      } from "./resources";


      import { 
      setupWater
      } from "./water";

      import { 
      setupSnow
      } from "./snow";

      import { 
      show_simple_message
      } from "./screen_message_Util";

      import { 
      convertForVrm
      } from "./mixamo";
      import { 
      signaling_url
      ,resolve_gimmick
      } from "./roomconf";
      
      var rtc_config = {'iceServers': [
        { urls: "stun:stun.l.google.com:19302" },
        { urls: "stun:stun1.l.google.com:19302" },
      ]};
      import {
        isAnimationDataLoaded,
        preLoadAnimationData,
        createAvatar
      } from "three-avatar";

      window.dic_bang = {};//bang済みid
      //無視対象
      
      window.command_can_use = {};
      window.command_prepare_task = {};
      //接続idをキーとしてクロージャの配列を値とする
      //commandがopenした時点で送信したいタスクを積む
      window.store_prepare_command= (id,task) =>{
        //使用可能な状態なら即送信
        if(id in window.command_can_use ){
          task();
          return;
        }
        
        if(!(id in window.command_prepare_task)){
          window.command_prepare_task[id]=[];
        };
        window.command_prepare_task[id].push(task);
      };
      window.resolve_prepare_command= (id) =>{
        console.log("resolve_prepare_command");
        if(id in window.command_prepare_task){
          console.log("tasks ",window.command_prepare_task[id].length);
          
          for(let task of window.command_prepare_task[id]){
            console.log("fetch task");
            task();
          };
          //積まれているのはオープン前なので消して問題ないはず
          delete window.command_prepare_task[id];
        };
      };

      window.dic_called_gimmick = {};//呼ばれたギミックを記録 １回だけ呼んでほしい場合の判定用
      var callbacks={
        onStateChange:(state)=>{
          console.log("state",state);
        },
        onJoin:async (id,connection)=>{
          console.log("join",id,connection);
          if("join_player" in window){
            await window.join_player(id);
          }
          if(window.buff_local_avatar){
            console.log("at join have avatar");
            //この時点ではcommandが開通してない可能性があるので予約
            window.store_prepare_command(id,()=>{
              //ファイルで設定したアバターがある
              //joinした相手に送信
              console.log("do req_send_avatar");
              /*
              let _data = window.buff_local_avatar;
              if(! (_data instanceof ArrayBuffer)){
                console.log("buff_local_avatar not ArrayBuffer");
              }
              var data = new ArrayBuffer(_data.byteLength);
              new Uint8Array(data).set(new Uint8Array(_data));
              */

              let data = window.buff_local_avatar;
              let send_key = window.make_file_send_key();
              window.dic_file_send_data[send_key] = data;
              let req = {
                action:"req_send_avatar",
                filesize:data.byteLength,
                send_key:send_key,
              }
              p2p_client.send(id,"command",JSON.stringify(req));
            });
          }else if(window.myavatar_idx){
            console.log("at join have no avatar idx=",window.myavatar_idx);

            window.store_prepare_command(id,()=>{
              window.cmd_avatar_partial(id,window.myavatar_idx);
            });
          }
        },
        onLeave:(id,connection)=>{
          console.log("leave",id,connection);
          if("leave_player" in window){
            if(id in dic_player){
              const other = dic_player[id];
              let uname = other.player_name;
              if(!uname){
                uname = id;
              };
              window.add_system_log("["+uname+"]が退室しました");
            }
            window.leave_player(id);
          }
        },
        onWelcome:(evt)=>{
          console.log("welcome",evt);
          window.my_id = evt.you;
          window.req_names();//住人の名前要求
          if("fix_collision" in window){
            //時々地形判定がおかしい
            window.fix_collision();
          }
          if("the_playerController" in window){
            window.the_playerController.moveController.enabled= true;
          }
        },
        onSysMessage:(evt)=>{
          //マスターからの汎用メッセージ
          //commandにcommandと同じ構造のデータ積む
          //マスターから部屋のギミック呼び出しとかに使う。
          const cmd = evt.command;
          if(cmd.action=="goto"){
            //移動ボタン表示
            window.add_goto_button("",cmd.dist);
          }else if(cmd.action=="gimmick"){
            //todo ギミック解決実装
            resolve_gimmick(cmd.code,cmd.target);
          }else if(cmd.action=="chat"){
            if(cmd.mode=="say"){
              window.add_system_log("マスター:"+cmd.chat);
            }else if(cmd.mode=="tell"){
              window.add_system_log("マスター>>あなた:"+cmd.chat);
            };
            show_simple_message(cmd.chat,1000);
          }
          
        },
        onDice:(evt)=>{
          //ダイスロール受信時
          console.log("dice",evt);
          let uname = "あなた";
          if(evt.sender in  dic_player){
            uname =  dic_player[evt.sender].player_name;
            if(!uname){
              uname = evt.sender;
            };
          };
          let msg = "["+uname+"]はサイコロを振った。"+evt.number+"D"+evt.size+"。出目は[";
          let total = 0;
          for(let r of evt.result){
            total += r;
          };
          msg += evt.result.join(",");
          msg += "] 合計 "+total;
          window.add_system_log(msg);
        },
        onExtChannel:async (id,dc) =>{
          if(dc.label in window.dic_file_receive_handler ){
            //設定されていれば受信コールバックを積む
            dc.onmessage = window.dic_file_receive_handler[dc.label];
          }
        },
        onNames:async (cmd) =>{
          //名前が来た
          if(cmd.names){
            if(typeof (cmd.names) == "object" ){
              for(let pid in cmd.names){
                if(!(pid in  window.dic_id2name)){
                  window.dic_id2name[pid] = cmd.names[pid];
                  window.add_system_log("["+cmd.names[pid]+"]が参加しました");
                }
                if(pid == window.my_id){
                  window.my_name = cmd.names[pid];
                  window.set_my_name(window.my_name);
                };
                if(pid in dic_player){
                  window.rpc_set_name(pid,cmd.names[pid]);
                }

              }
            }
          }
        },
        onBang:async (cmd) =>{
          //誰かBangされた
          if(cmd.target in p2p_client.dic_connection){
            window.leave_player(cmd.target);
            window.dic_bang[cmd.target]=1;
            p2p_client.dic_connection[cmd.target].pc.close();
            const uname = window.dic_id2name[cmd.target];
            window.add_system_log("["+uname+"]が追放されました");
            delete p2p_client.dic_connection[cmd.target];
            //削除はしないほうが無難かも
          }
        },
        onMic:async ()=>{
          //マイクが有効
          console.log("available mic");
          //マイク音量調整ボタンを有効にする
          const btn = document.getElementById("btn_mic");
          if(btn){
            btn.onclick = async (e) =>{
              let org_vol = p2p_client.getMicVolume();
              let alt_vol = await sliderAsync("マイク音量",
                {
                  default_value:org_vol,
                  on_input:(v)=>{
                    p2p_client.setMicVolume(v);
                  }
                }
              );
              if(alt_vol===false){
                p2p_client.setMicVolume(org_vol);
              }else{
                p2p_client.setMicVolume(alt_vol);
              }
            };
            btn.style.display="";
          }
        },
        onAudio:(id,stream)=>{
          console.log("onAudio",id,stream);
          window.dic_id2voice[id]=stream;
          window.setup_voice(id);//join済みの場合の対応
        }
      }
      window.dic_id2voice ={};
      window.setup_voice = (id) =>{
        if((id in window.dic_player) && (id in  dic_id2voice)){
          //プレイヤーにpositionalaudioを追加してstreamを付ける
          const other = window.dic_player[id];
          if(other.has_voice){
            return;
          }
          const stream = dic_id2voice[id];

          //todoもう少しましな判別
          let is_chrome = false;
          if("userAgentData" in navigator){
            is_chrome = navigator.userAgentData.brands[1].brand=='Google Chrome';
          }
          
          if(is_chrome){
            //chromeではaudio要素を介さないと再生されない
            //困ったことにaudio要素を使った場合
            //PositionalAudioによる位置の効果が効いてない
            //ので使わない

            var el = document.createElement('audio');
            el.srcObject = stream;
            el.play();
            other.has_voice = true;
            other.setVolume = (v) =>{
              el.volume = v;
            };
            other.getVolume = () =>{
              return el.volume;
            };
          }else{
            //forefoxではmediastreamをそのまま使える
            //safariも使えている
            //他のブラウザは要調査
            const audio = new THREE.PositionalAudio(window.mylistener);
            const refDis = 1; // 音量が下がり始める距離
            const rolloff = 2; // 音源から遠ざかった時にどのくらいすぐに音量が下がるか
            const volume = 1;
            //audio.autoplay = true;
            window.AudioContext = window.AudioContext || window.webkitAudioContext;
            const context = new AudioContext();
            audio.setMediaStreamSource(stream);
            audio.setRefDistance(refDis);
            audio.setRolloffFactor(rolloff);
            audio.setVolume(volume);
            other.add(audio);
            
            other.setVolume = (v) =>{
              audio.setVolume(v);
            };
            other.getVolume = () =>{
              return audio.getVolume();
            };
            other.has_voice = true;
          }
          
          console.log("append voicd to ",id);
        }
        
      }

      
      const RPC_AVATAR=0x00001;
      

      const channels={
        "transform":{
          type:"transform",
          onDataOpen:(id)=>{
            console.log("open",id,"transform");
            if("req_sync_player_partial" in window){
              window.req_sync_player_partial(id);
            }
          },
          onData:(id,data)=>{
            if(id in window.dic_bang){
              return;
            }
            let transform = unpack_transform(data);
            if("sync_player" in window){
              window.sync_player(id,transform);
            }
          },
          onDataClose:(id)=>{
            console.log("close",id);
          }
        },

        "rpc":{
          type:"rpc",
          onDataOpen:(id)=>{
            console.log("open",id,"rpc");
          },
          onData:(id,data)=>{
            if(id in window.dic_bang){
              return;
            }

            var view = new DataView(data);
            let type=view.getUint16(0);
            if(type==RPC_AVATAR){
              let idx = view.getUint16(2);
              if("rpc_avatar" in window){
                console.log("!!!! receive rpc avatar");
                window.rpc_avatar(id,idx);
              }
            }
          },
          onDataClose:(id)=>{
            console.log("close",id);
          }
        },


        "command":{
          type:"chat",
          onDataOpen:(id)=>{
            console.log("open",id,"command");
            window.command_can_use[id]=1;
            //予約コマンド解決
            window.resolve_prepare_command(id);
          },
          onData:async (id,data)=>{
            if(id in window.dic_bang){
              console.log("its banged ",id)
              return;
            }


            //json形式で来る
            //actionで種別
            let cmd = JSON.parse(data);

            console.log(cmd);

            if(cmd.action=="req_send_avatar"){
              //アバターを送信したいという要求がきた
              //filesize が入っている
              let send_key = cmd.send_key;
              let receive_key = window.make_file_receive_key();
              window.prepare_receive_avatar(id,cmd.filesize,send_key,receive_key);
              let res = {
                action:"ready_send_file",
                send_key:send_key,
                receive_key:receive_key,
              };
              p2p_client.send(id,"command",JSON.stringify(res));
            }else if(cmd.action=="req_show_spotlight"){
              //スポットライトを表示する要求が来た
              //ファイル転送は不要なので即座に表示する
              let send_key = cmd.send_key;
              rpc_show_spotlight(id,send_key);
            }else if(cmd.action=="req_send_fbx"){
              //fbxを送信したいという要求がきた
              //このシステムでのfbxはmixamoのアニメーションデータ
              //モデルは対象外
              //filesize が入っている
              let send_key = cmd.send_key;
              let motion_name = cmd.motion_name;
              let receive_key = window.make_file_receive_key();
              window.prepare_receive_fbx(id,cmd.filesize,send_key,receive_key,motion_name);
              let res = {
                action:"ready_send_file",
                send_key:send_key,
                receive_key:receive_key,
              };
              p2p_client.send(id,"command",JSON.stringify(res));
            }else if(cmd.action=="req_send_image"){
              //画像を送信したいという要求がきた
              //filesize が入っている
              let send_key = cmd.send_key;
              let receive_key = window.make_file_receive_key();
              window.prepare_receive_image(id,cmd.filesize,send_key,receive_key);
              let res = {
                action:"ready_send_file",
                send_key:send_key,
                receive_key:receive_key,
              };
              p2p_client.send(id,"command",JSON.stringify(res));

            }else if(cmd.action=="req_send_audio"){
              //videoを送信したいという要求がきた
              //filesize が入っている
              let send_key = cmd.send_key;
              let receive_key = window.make_file_receive_key();
              window.prepare_receive_audio(id,cmd.filesize,send_key,receive_key);
              let res = {
                action:"ready_send_file",
                send_key:send_key,
                receive_key:receive_key,
              };
              p2p_client.send(id,"command",JSON.stringify(res));

            }else if(cmd.action=="req_send_video"){
              //videoを送信したいという要求がきた
              //filesize が入っている
              let send_key = cmd.send_key;
              let receive_key = window.make_file_receive_key();
              window.prepare_receive_video(id,cmd.filesize,send_key,receive_key);
              let res = {
                action:"ready_send_file",
                send_key:send_key,
                receive_key:receive_key,
              };
              p2p_client.send(id,"command",JSON.stringify(res));

            }else if(cmd.action=="req_send_glb"){
              //glbを送信したいという要求がきた
              //filesize が入っている
              let send_key = cmd.send_key;
              let receive_key = window.make_file_receive_key();
              window.prepare_receive_glb(id,cmd.filesize,send_key,receive_key);
              let res = {
                action:"ready_send_file",
                send_key:send_key,
                receive_key:receive_key,
              };
              p2p_client.send(id,"command",JSON.stringify(res));

            }else if(cmd.action=="req_send_ply"){
              //plyを送信したいという要求がきた
              //filesize が入っている
              let send_key = cmd.send_key;
              let receive_key = window.make_file_receive_key();
              window.prepare_receive_ply(id,cmd.filesize,send_key,receive_key);
              let res = {
                action:"ready_send_file",
                send_key:send_key,
                receive_key:receive_key,
              };
              p2p_client.send(id,"command",JSON.stringify(res));
            }else if(cmd.action=="ready_send_file"){
              window.resolve_upload_file(id,cmd.send_key,cmd.receive_key);

            }else if(cmd.action=="req_move_obj"){
              window.resolve_move_obj(cmd);
            }else if(cmd.action=="req_delete_obj"){
              window.resolve_delete_obj(cmd);
            }else if(cmd.action=="emote"){
              if(cmd.motion in ANIMATION_MAP){
                if(id in dic_player){
                  let other = dic_player[id];
                  other.avatar.stopClip();
                  if(cmd.motion in dic_nonloop_animation){
                    other.avatar.playClipOnce(cmd.motion);
                  }else{
                    other.avatar.playClip(cmd.motion);
                  }
                }
              }else{
                //モーション無いから送信者に転送要求
                let res = {
                  action:"req_motion",
                  motion:cmd.motion,
                };
                //届いたときに再生してほしいモーション
                window.dic_wished_motion[cmd.motion] = id;
                p2p_client.send(id,"command",JSON.stringify(res));
              }
            }else if(cmd.action=="req_motion"){
              //要求されたモーションを送信する
              if(cmd.motion in window.dic_motion_data){
                let data = window.dic_motion_data[cmd.motion];

                //対象プレイヤーのアバターにモーション追加が必要
                if(id in dic_player){
                  let avatar = dic_player[id].avatar;
                  await addAnimation2AvatarFromArrayBuffer(avatar,cmd.motion,data);
                }

                let send_key = window.make_file_send_key();
                let filesize = data.byteLength;
                window.dic_file_send_data[send_key] = data;
                let res = {
                  action:"req_send_fbx",
                  send_key:send_key,
                  filesize:filesize,
                  motion_name:cmd.motion,
                };
                p2p_client.send(id,"command",JSON.stringify(res));
              }
            }else if(cmd.action=="goto"){
              //移動ボタン表示
              window.add_goto_button(id,cmd.dist);
            }else if(cmd.action=="chat"){
              window.rpc_set_chat(id,cmd.chat);
              let is_tell = (cmd.mode=="tell");
              window.add_chat_log(id,null,cmd.chat,is_tell);
            }else if(cmd.action=="req_your_name"){
              return;//host-clientモードでは使わない
              //名前を要求された場合
              let my_name = window.my_name;
              if(!my_name){
                my_name = "";
              };
              let res = {
                action:"my_name_is",
                name:my_name,
              };
              p2p_client.send(id,"command",JSON.stringify(res));
            }else if(cmd.action=="my_name_is"){
              return;//host-clientモードでは使わない
              //名前を教えてもらった
              window.rpc_set_name(id,cmd.name); 
            }else{
            }
          },
          onDataClose:(id)=>{
            console.log("close",id);
          }
        },
      };

      function joinArrayBuffer(segments){
        var sumLength = 0;
        for(var i = 0; i < segments.length; ++i){
          sumLength += segments[i].byteLength;
        }
        var whole = new Uint8Array(sumLength);
        var pos = 0;
        for(var i = 0; i < segments.length; ++i){
          whole.set(new Uint8Array(segments[i]),pos);
          pos += segments[i].byteLength;
        }
        return whole.buffer;
      }


      window.file_send_index = 0;
      window.file_receive_index = 0;
      window.make_file_send_key = () =>{
        window.file_send_index+=1;
        return window.my_id + "_"+window.file_send_index;
      }
      window.make_file_receive_key = () =>{
        window.file_receive_index+=1;
        return window.my_id + "_"+window.file_receive_index;
      }
      
      window.dic_file_send_data = {};
      //送信データ
      //send_keyをキーとしてArrayBufferを値とする
      //readyが来た時にreceive_keyをチャネル名として送信する
      //send_large_extで送信する。
      
      window.dic_file_receive_handler = {};
      //受信ハンドラ
      //receive_keyをキーとして、onExtChannel時に
      //onmessageに設定する
      
      window.dic_spawn_object = {};
      //send_keyをキーとして生成したオブジェクトを値とする
      
      window.in_upload_resource = false;
      window.upload_text_resource = async (file_upload,handler)=>{
        await window.upload_resource(file_upload,handler,"text");
      };
      window.upload_resource = async (file_upload,handler,mode="binary")=>{
        console.log("upload_resource called ");
        if(window.in_upload_resource){
          await alertAsync("アップロード中です");
          return;
        }
        if(file_upload.files.length<1){
          await alertAsync("ファイルが選択されていません");
          return;
        }
        window.in_upload_resource=true;
        let file = file_upload.files[0];
        let filename = file.name;
        var fileReader = new FileReader();
        fileReader.onloadend =async function (e) {
          var data = e.target.result;
          await handler(data);
          window.in_upload_resource=false;
          file_upload.value="";//2024-09-01 リセットしないと同じファイルを使えない
        };
        if(mode=="text"){
          fileReader.readAsText(file);
        }else{
          fileReader.readAsArrayBuffer(file);
        }
      }
      window.resolve_upload_file = async (id,send_key,receive_key) =>{
        let data = window.dic_file_send_data[send_key];
        await p2p_client.send_large_ext(id,receive_key,data);
        delete window.dic_file_send_data[send_key];
      };

      


      window.addAnimation2AvatarFromArrayBuffer = async (avatar,keyname,data) =>{
        const motion = new FBXLoader().parse(
          data,
          "about:blank" // No additional data is needed. about:blank
        );
        const clip = convertForVrm(motion, avatar._vrm, keyname);
        let new_idx = avatar._vrm.scene.animations.length;
        avatar._vrm.scene.animations[new_idx]=clip;
      };


      window.addAnimation2Avatar = async (avatar,keyname,url) =>{
        const data = await (await fetch(url)).arrayBuffer();
        window.addAnimation2AvatarFromArrayBuffer(avatar,keyname,data);
      };
      

      window.setupAvatar = (avatar)=>{
        //アバター用の拡張メソッド等の設定
        //playClipはループ強制なので１ショット用追加
        avatar.playClipOnce=(motion)=>{
          avatar._mixer.stopAllAction();
          const clip = avatar._getClip(motion,false);
          avatar._activeAction = avatar._mixer.clipAction(clip);
          avatar._activeAction.setLoop(THREE.LoopOnce)
          avatar._activeAction.clampWhenFinished = true
          avatar._activeAction.play();
        };
        
        //影表示
        avatar._object3D.traverse(
          (object) => { //モデルの構成要素
            if(object.isMesh) { //その構成要素がメッシュだったら
              object.castShadow = true;//影表示
              //object.receiveShadow = true;//影表示
              object.material.metalness = 0;//これしないと暗くなる
            }
          }
        );

      };

      window.loadVrmAsAvatar =  async (url,name)=>{
        const renderer = window.the_renderer;
        if (!isAnimationDataLoaded()) {
          await preLoadAnimationData(ANIMATION_MAP);
        }

        let resp = await fetch(url);
        const avatarData = new Uint8Array(await resp.arrayBuffer());
        let _avatar = await createAvatar(
          avatarData, 
          renderer, 
          false, 
          {
          }
        );
        _avatar._object3D.name = name;
        window.setupAvatar(_avatar);
        return _avatar;
      }

      window.loadVrmAsAvatarFromArrayBuffer =  async (buffer,name)=>{
        const renderer = window.the_renderer;
        if (!isAnimationDataLoaded()) {
          //実際にはここは通らない
          await preLoadAnimationData(ANIMATION_MAP);
        }
        const avatarData = new Uint8Array(buffer);
        let _avatar = await createAvatar(
          avatarData, 
          renderer, 
          false, 
          {
          }
        );
        _avatar._object3D.name = name;
        window.setupAvatar(_avatar);
        return _avatar;
      }





      window.dic_player = {};//user-idをキーとする 値はavatarでよかったか？
      var dic_player_transform = {};//アバターできる前に通知が来る場合があるので
      var dic_player_avatar = {};//アバターidx
      

      window.sync_player = (id,transform) =>{
        if(id in dic_player){
          let _player = dic_player[id];
          _player.wish_pos = transform.position;
          _player.wish_rot = transform.rotation;
        }else{
          dic_player_transform[id]=transform;
        }
      }
      window.req_sync_player = () =>{
        let transform = {
          position:window.myplayer.position,
          rotation:window.myplayer.rotation,
          ts:Date.now()
        };
        //console.log(transform.rotation.y);
        let data = pack_transform(transform);
        p2p_client.broadcast("transform",data);
      };

      window.req_sync_player_partial = (id) =>{        
        let transform = {
          position:window.myplayer.position,
          rotation:window.myplayer.rotation,
          ts:Date.now()
        };
        //console.log(transform.rotation.y);
        let data = pack_transform(transform);
        p2p_client.send(id,"transform",data);
      };

      const _createElement = (eltype,nocontextmenu=true) =>{
        const el = document.createElement(eltype);
        if(nocontextmenu){
          el.oncontextmenu= () =>{ return false; };
              
        };
        return el;
      };

      const new_CSS3DSprite = (src) =>{
        const sprite = new CSS3DSprite(src);
        sprite.oncontextmenu= () =>{ return false; };
        return sprite;
      }; 
      
      window.say_chat = (chat) =>{
        window.add_chat_log(null,null,chat,false);
        let res = {
          action:"chat",
          chat:chat,
          mode:"say"
        };
        p2p_client.broadcast("command",JSON.stringify(res));
      }

      window.tell_chat = (id,chat) =>{
        window.add_chat_log(null,id,chat,true);
        let res = {
          action:"chat",
          chat:chat,
          mode:"tell"
        };
        p2p_client.send(id,"command",JSON.stringify(res));
      }

      
      window.rpc_set_chat = (id,chat) =>{
        if(id in dic_player){
          let obj = dic_player[id];
          if("updateOtherPersonMessage" in obj){
            obj.updateOtherPersonMessage(chat);
          }
        }
      }
      
      window.rpc_set_name = (id,name) =>{
        if(id in dic_player){
          let obj = dic_player[id];
          if(!obj.nameLabel){
            //名札がない場合は作る
            const label = _createElement("div");
            label.className = "name-label";
            obj.nameLabel = label;
            const message_ui = _createElement("div");
            message_ui.className="otp_message";
            obj._message_ui = message_ui;
            obj.updateOtherPersonMessage = (v) =>{
              obj._message_ui.innerHTML = v;
            };
            //本体消滅の検知
            let _check_label  = function(_id,lbl,mui){
              //console.log(op,lbl);
              if(!(_id in dic_player)){
                console.log("no using label then destroy");
                lbl.remove();
                mui.remove();
                return;
              }
              setTimeout(
                function(){
                  _check_label(_id,lbl,mui);
                },
                1000
              );
            };
            _check_label(id,label,obj._message_ui);
            const cssObject = new_CSS3DSprite(label);
            cssObject.position.y=2;
            cssObject.scale.setScalar(0.01);
            cssObject.rotation.set(0, THREE.MathUtils.degToRad(180), 0);
            obj.cssObject = cssObject;
            obj.add(cssObject);
            obj.onSelectDown = async () => {
              let _buttons = [];

              _buttons.push(
              {
                caption:"対話",
                value:"tell",
              });

              _buttons.push(
              {
                caption:"ブロック",
                value:"block",
              });

              if(other.has_voice){
                _buttons.push(
                {
                  caption:"ボイス音量",
                  value:"voice_volume",
                });
              }


              _buttons.push(
              {
                caption:"中止",
                value:"cancel",
              });


              const mode = await choiceAsync("",{buttons:_buttons});
              if(mode=="tell"){
                await window.proc_tell_input(id);

              }else if(mode=="voice_volume"){

                let org_vol = other.getVolume();
                let alt_vol = await sliderAsync("ボイス音量",
                  {
                    default_value:org_vol,
                    on_input:(v)=>{
                      other.setVolume(v);
                    }
                  }
                );
                if(alt_vol===false){
                  other.setVolume(org_vol);
                }else{
                  other.setVolume(alt_vol);
                }
              }else if(mode=="block"){

                window.leave_player(id);
                window.dic_bang[id]=1;
                p2p_client.dic_connection[id].pc.close();
                const uname = window.dic_id2name[id];
                window.add_system_log("["+uname+"]をブロックしました");

                delete p2p_client.dic_connection[id];
                //削除はしないほうが無難かも
              }
            
            }; 
            window.arr_interactive.push(obj);
            const cssObject_message = new_CSS3DSprite(message_ui);
            cssObject_message.position.y=2.3;
            cssObject_message.scale.setScalar(0.01);
            cssObject_message.rotation.set(0, THREE.MathUtils.degToRad(180), 0);
            obj.cssObject_message = cssObject_message;
            obj.add(cssObject_message);


          };
          obj.nameLabel.textContent = name;
          obj.player_name = name;
        }
      }

      
      

      
      window.ArrayBufferToString = (buff) =>{
        var enc = new TextDecoder("utf-8");
        const arr = new Int8Array(buff);
        return enc.decode(arr);
      };

      window.prepare_receive_ply = (id,filesize,send_key,receive_key) =>{
        let info = {filesize:filesize,buffers:[],amount:0};
        window.dic_file_receive_handler[receive_key] = async (evt) =>{
          let data = evt.data;
          let target = id;
          let amount = info.amount;
          info.buffers.push(data);
          let sz = data.byteLength;
          amount+=sz;
          info.amount = amount;
          if(amount >= info.filesize){
            //受信完了したので結合して対象プレイヤーの位置に表示
            let _fulldata = joinArrayBuffer(info.buffers);
            //文字列に戻す
            let fulldata = window.ArrayBufferToString(_fulldata);
            await rpc_show_ply(id,fulldata,send_key);
          }else{
          }
        }
      }

      window.local_show_ply = async (data,send_key) =>{
        window.showPly(window.myplayer,data,send_key);
      }
      
      window.rpc_show_ply = async (id,data,send_key) =>{
        if(id in dic_player){
          window.showPly(dic_player[id],data,send_key);
        }
      };
      
      window.uploadPly = async (file_upload) =>{
        await window.upload_text_resource(file_upload,async (data)=>{
          var enc = new TextEncoder(); // always utf-8
          let send_key = window.make_file_send_key();
          window.local_show_ply(data,send_key);
          //send_largeはバイナリ用なので変換
          var _data = enc.encode(data).buffer;
          window.dic_file_send_data[send_key] = _data;
          let filesize = _data.byteLength;
          let res = {
            action:"req_send_ply",
            filesize:filesize,
            send_key:send_key,
          };
          p2p_client.broadcast("command",JSON.stringify(res));
        });
      }
      window.setup_tr_con = (obj) =>{
        obj.in_tr_con = false;
        obj.onSelectDown = () => {
          if(!obj.in_tr_con){
            window.show_tr_con(obj);
          }else{
            //長押しの場合は確定扱い
            window.submit_tr_edit();
            window.hide_tr_con(obj);
          }
        }
        window.arr_interactive.push(obj);
      };
      
      window.org_camera_pos = new THREE.Vector3();
      window.org_camera_rot = new THREE.Euler();
      window.tr_con_using = false;
      window.orbitControls = null;

      window.resolve_delete_obj = (cmd) =>{
        if(cmd.send_key in window.dic_spawn_object){
          let obj =window.dic_spawn_object[cmd.send_key];
          window.the_scene.remove(obj);
          //todo objの開放処理
          //arr_interactiveから削除
          let org = window.arr_interactive;
          let alt = [];
          for(let o of org){
            if(o===obj){
            }else{
              alt.push(o);
            }
          }
          window.arr_interactive = alt;
          if(obj.isMesh){
            //それ自体がメッシュ
            obj.geometry.dispose();
            obj.material.dispose();
          }else{
            //glbとかだと単一じゃないので
            obj.traverse(
              (_obj) => { //モデルの構成要素
                if(_obj.isMesh) { //その構成要素がメッシュだったら
                  _obj.geometry.dispose();
                  _obj.material.dispose();
                }
              }
            );
          }

          if(obj.video){
            console.log("deleteImage its video");
            obj.video.pause();
            obj.video.remove();
          }
          //audioも同様
          if(obj.audio){
            console.log("deleteImage audio");
            obj.audio.pause();
            //obj.audio.remove();//domじゃないので
          }


          
          delete window.dic_spawn_object[cmd.send_key];
        }else{
          console.log("not found ", cmd.send_key);
        }
      }

      window.req_delete_obj = (obj) =>{
        let send_key = obj.send_key;
        let res = {
          action:"req_delete_obj",
          send_key:send_key,
        };
        let cmd = JSON.stringify(res);
        p2p_client.broadcast("command",cmd);
        console.log("to resolve",cmd);
        resolve_delete_obj(res);
      }

      window.tr_draging = false;
      window.show_tr_con = async (obj) =>{
        //対象にtransform_controlつける
        //move_controllerを一時無効化
        if(!obj){
          return;
        }
        if(!(obj.send_key in window.dic_spawn_object)){
          return;
        }

        
        let _buttons = [];
        if("video" in obj){
          if(obj.video.paused){
            _buttons.push(
            {
                caption:"再生",
                value:"play_video",
            });
          }else{
            _buttons.push(
            {
              caption:"停止",
              value:"pause_video",
            });
          };

          _buttons.push(
          {
              caption:"音量",
              value:"volume_video",
          });


          
        }


        if("spotlight" in obj){
          _buttons.push(
          {
              caption:"光量",
              value:"intensity_spotlight",
          },
          {
              caption:"照射角",
              value:"angle_spotlight",
          },
          );
        }


        if("audio" in obj){
          if(!obj.audio.isPlaying){
            _buttons.push(
            {
                caption:"再生",
                value:"play_audio",
            });
          }else{
            _buttons.push(
            {
              caption:"停止",
              value:"pause_audio",
            });
          };

          _buttons.push(
          {
              caption:"音量",
              value:"volume_audio",
          });
          
        }

        _buttons.push(
          {
            caption:"位置",
            value:"pos",
          });
        _buttons.push(
          {
            caption:"回転",
            value:"rot",
          });

        _buttons.push(
          {
            caption:"大きさ",
            value:"siz",
          });

        _buttons.push(
          {
            caption:"削除",
            value:"del",
          });

        _buttons.push(
          {
            caption:"中止",
            value:"cancel",
          });

        
        let mode = await choiceAsync("編集",
          {
            buttons:_buttons
          }
        );
        if(mode=="cancel"){
          
          return;
        }

        if(mode=="pause_video"){
          obj.video.pause();
          return;
        }
        if(mode=="play_video"){
          obj.video.play();
          return;
        }

        if(mode=="mute_video"){
          obj.video.muted=true;
          obj.video.volume=0;
          return;
        }

        if(mode=="unmute_video"){
          obj.video.muted=false;
          obj.video.volume=1;
          return;
        }

        if(mode=="intensity_spotlight"){
          let org_v = obj.spotlight.intensity;
          let alt_v = await sliderAsync("光量",
            {
              default_value:org_v,
              step_value:0.1,
              min_value:0.0,
              max_value:10.0,
              on_input:(v)=>{
                obj.spotlight.intensity = v*1.0;
              }
            }
          );
          if(alt_v===false){
            obj.spotlight.intensity = org_v*1.0;
          }else{
            obj.spotlight.intensity = alt_v*1.0;
          }
          return;

        }

        if(mode=="angle_spotlight"){
          let org_v = obj.spotlight.angle;
          let alt_v = await sliderAsync("光量",
            {
              default_value:org_v,
              step_value:0.02,
              min_value:0.0,
              max_value:2.0,
              on_input:(v)=>{
                obj.spotlight.angle = v*1.0;
              }
            }
          );


          if(alt_v===false){
            obj.spotlight.angle = org_v*1.0;
          }else{
            obj.spotlight.angle = alt_v*1.0;
          }
          return;
        }

        if(mode=="volume_video"){
          let org_vol = obj.video.volume;
          let alt_vol = await sliderAsync("音量",
            {
              default_value:org_vol,
              on_input:(v)=>{
                obj.video.muted = (v<=0);
                obj.video.volume=v;
              }
            }
          );
          if(alt_vol===false){
            obj.video.volume=org_vol;
            obj.video.muted = (org_vol<=0);
          }else{
            obj.video.volume=alt_vol;
            obj.video.muted = (alt_vol<=0);
          }
          return;
        }



        if(mode=="volume_audio"){
          let org_vol = obj.audio.getVolume();
          let alt_vol = await sliderAsync("音量",
            {
              default_value:org_vol,
              on_input:(v)=>{
                obj.audio.setVolume(v);
              }
            }
          );
          if(alt_vol===false){
            obj.audio.setVolume(org_vol);
          }else{
            obj.audio.setVolume(alt_vol);
          }
          return;
        }


        if(mode=="pause_audio"){
          if(obj.clipAction){
            obj.clipAction.stop();
          }
          obj.audio.pause();
          return;
        }
        if(mode=="play_audio"){
          if(obj.clipAction){
            obj.clipAction.play();
          }
          obj.audio.play();
          return;
        }

        if(mode=="mute_audio"){
          if(obj.clipAction){
            obj.clipAction.stop();
          }

          obj.audio.setVolume(0);
          return;
        }

        if(mode=="unmute_audio"){
          if(obj.clipAction){
            obj.clipAction.play();
          }
          obj.audio.setVolume(1);
          return;
        }


        if(mode=="del"){
          window.req_delete_obj(obj);
          return;
        }

        if(mode=="siz"){
          let default_value =  obj.scale.y;
          let sc = await promptAsync("倍率",{default_value:default_value});
          sc = 1.0*sc;
          if(!sc || isNaN(sc)){
            sc=default_value;
          }
          obj.scale.set(sc,sc,sc);
          window.submit_tr_edit(obj);
          return;
        }

        
        
        //カメラ位置退避
        window.org_camera_pos.copy(window.mycamera.position);
        window.org_camera_rot.copy(window.mycamera.rotation);

        if(!window._freeCamera){
          window.setupFreeCamera(window.the_scene,window.mycamera);
        }
        window.the_playerController.moveController.enabled = false;
        window.the_playerController.touchController.enabled = false;
        //カメラ位置はメインカメラのワールド位置
        //カメラ対象はobjの位置とする。
        let pos = window.mycamera.getWorldPosition(new THREE.Vector3());
        let tpos = obj.getWorldPosition(new THREE.Vector3());

        window._freeCamera.position.set(pos.x,pos.y,pos.z);
        window._freeCameraControlls.target = tpos;
        window._freeCameraControlls.enabled=true;
        window._freeCameraControlls.update();
        window._freeCameraControlls.saveState()
        window.the_playerController.xrController._pointerControllerL._camera=window._freeCamera;
        window.the_playerController.xrController._pointerControllerR._camera=window._freeCamera;
        window._useFreeCamera = true;

        obj.in_tr_con = true;
        const transControls = new TransformControls(window._freeCamera, window.the_renderer.domElement);
        transControls.addEventListener('change', ()=>{
          window.the_renderer.render(window.the_scene, window._freeCamera);        
        });
        //操作中はカメラ動かさない
        transControls.addEventListener('dragging-changed', event => {
          if(window.tr_con_using){
            window.tr_draging=event.value;
            window._freeCameraControlls.enabled = !event.value;
          }else{
            window.tr_draging=false;
            window._freeCameraControlls.enabled = false;
          }
        });
        transControls.attach(obj);

        if(mode=="pos"){
          transControls.setMode('translate');
        }else if(mode=="rot"){
          transControls.setMode('rotate');
        }else if(mode=="siz"){
          transControls.setMode('scale');
        }

        current_tr_con = transControls;
        window.the_scene.add(transControls);
        window.tr_target = obj;
        window.org_tr_position.copy(obj.position);
        window.org_tr_rotation.copy(obj.rotation);
        window.org_tr_scale.copy(obj.scale);
        window.tr_con_using = true;
      }
      window.hide_tr_con = (obj) =>{
        //transform_controlを外す
        //move_controllerを有効化
        if(!window.current_tr_con){
          return;
        }
        window.tr_con_using = false;
        obj.in_tr_con = false;

        //カメラ戻す
        window.the_playerController.moveController.enabled = true;
        window.the_playerController.touchController.enabled = true;
        window._freeCameraControlls.enabled = false;
        window.the_playerController.xrController._pointerControllerL._camera=window.mycamera;
        window.the_playerController.xrController._pointerControllerR._camera=window.mycamera;
        window._useFreeCamera = false;

        window.current_tr_con.detach();
        window.the_scene.remove(window.current_tr_con);
        window.current_tr_con = null;
        window.tr_target = null;
      }
      window.tr_target = null;
      window.org_tr_position=new THREE.Vector3();
      window.org_tr_rotation=new THREE.Euler();
      window.org_tr_scale = new THREE.Vector3();
      window.current_tr_con = null;//現在のtransform_control
      window.submit_tr_edit = (obj=null) =>{
        
        if(!obj){
          obj = obj = window.tr_target;
        }
        let send_key = obj.send_key;
        let pos = {x:obj.position.x,y:obj.position.y,z:obj.position.z};
        let rot = {x:obj.rotation.x,y:obj.rotation.y,z:obj.rotation.z};
        let siz = {x:obj.scale.x,y:obj.scale.y,z:obj.scale.z};

        let res = {
          action:"req_move_obj",
          send_key:send_key,
          position:pos,
          rotation:rot,
          scale:siz,
        };
        p2p_client.broadcast("command",JSON.stringify(res));
      }
      
      window.addEventListener('keydown', event => {



        if(!window.current_tr_con){
          return;
        }


        switch (event.keyCode) {
          case 13: // ENTER = submit
            //todo 設定値を送信して終了
            window.submit_tr_edit();
            window.hide_tr_con(window.tr_target);
            break;

          case 27: // ESC = cancel
            //元の位置に戻して終了
            window.tr_target.position.copy(org_tr_position);
            window.tr_target.rotation.copy(org_tr_rotation);
            window.tr_target.scale.copy(org_tr_scale);
            window.hide_tr_con(window.tr_target);
            break;

          case 71: // G = position
            current_tr_con.setMode('translate');
            break;
          case 82: // R = rotate
            current_tr_con.setMode('rotate');
            break;
          case 83: // S = scale
            current_tr_con.setMode('scale');
            break;

        }
      });      
      window.resolve_move_obj = (cmd) =>{
        if(cmd.send_key in window.dic_spawn_object){
          let obj = window.dic_spawn_object[cmd.send_key];
          obj.position.x = cmd.position.x;
          obj.position.y = cmd.position.y;
          obj.position.z = cmd.position.z;
          obj.rotation.x = cmd.rotation.x;
          obj.rotation.y = cmd.rotation.y;
          obj.rotation.z = cmd.rotation.z;
          obj.scale.x = cmd.scale.x;
          obj.scale.y = cmd.scale.y;
          obj.scale.z = cmd.scale.z;
        }
      }

      window.showPly = async (base_obj,data,send_key) =>{
        //console.log(data);
        //return;
        
        let obj = await loadPlyFromText(data);
        
        window.the_ply = obj;
        the_scene.add(obj);
        
        obj.position.set(base_obj.position.x,base_obj.position.y,base_obj.position.z);
        obj.rotation.y = base_obj.rotation.y + Math.PI;
        window.dic_spawn_object[send_key]=obj;
        obj.send_key = send_key;
        //位置設定ui付与
        window.setup_tr_con(obj);
      };

      window.rpc_avatar_avatar = async (id,avatar) =>{
        if(id in dic_player){
          let obj = dic_player[id];
          obj.remove(obj.avatar._object3D);
          obj.add(avatar._object3D);
          obj.avatar = avatar;
          obj.avatar_idx = 0;
        }else{
          //dic_player_avatar[id]=idx;
        }
      }

      
      window.prepare_receive_image = (id,filesize,send_key,receive_key) =>{
        let info = {filesize:filesize,buffers:[],amount:0};
        window.dic_file_receive_handler[receive_key] = async (evt) =>{
          let data = evt.data;
          let target = id;
          let amount = info.amount;
          info.buffers.push(data);
          let sz = data.byteLength;
          amount+=sz;
          info.amount = amount;
          if(amount >= info.filesize){
            //受信完了したので結合して対象プレイヤーの位置に表示
            let fulldata = joinArrayBuffer(info.buffers);
            await rpc_show_image(id,fulldata,send_key);
          }else{
          }
        }
      }
      window.local_show_image = async (data,send_key) =>{
        window.showImage(window.myplayer,data,send_key);
      }
      window.rpc_show_image = async (id,data,send_key) =>{
        if(id in dic_player){
          window.showImage(dic_player[id],data,send_key);
        }
      };
      window.uploadImage = async (file_upload) =>{
        await window.upload_resource(file_upload,async (data)=>{
          let send_key = window.make_file_send_key();
          window.local_show_image(data,send_key);
          window.in_upload_image=false;
          let filesize = data.byteLength;
          window.dic_file_send_data[send_key] = data;
          let res = {
            action:"req_send_image",
            send_key:send_key,
            filesize:filesize,
          };
          p2p_client.broadcast("command",JSON.stringify(res));
        });
      }
      
      window.showImage = async (base_obj,data,send_key) =>{
        const blob = new Blob([data]);
        let url =  window.URL.createObjectURL(blob);
        let loader = new THREE.TextureLoader();
        let tex = await loader.loadAsync(url);
        if(!tex){
          console.log("showimage texture load fail");
          return;
        }

        // 縦横比を保って適当にリサイズ
        const h = 3;//本当は縦横の大小で固定する側を変えるほうがいい
        const w = tex.image.width / (tex.image.height/h);
        

        // 平面
        const geometry = new THREE.PlaneGeometry(w, h);
        const material = new THREE.MeshBasicMaterial( { map:tex } );
        const plane = new THREE.Mesh( geometry, material );

        //裏から認識したいので２面作る
        const material2 = new THREE.MeshBasicMaterial({ color: 0xf8ddb7 });
        const plane2 = new THREE.Mesh( geometry, material2 );

        const obj = new THREE.Object3D();
        obj.add(plane);
        obj.add(plane2);

        //入れ子にして底辺をy=0にする
        plane.position.y = h/2;
        plane2.position.y = h/2;
        plane2.position.z = -0.01;
        plane2.rotation.y = Math.PI;
        the_scene.add(obj);
        
        obj.position.set(base_obj.position.x,base_obj.position.y,base_obj.position.z);
        obj.rotation.y = base_obj.rotation.y + Math.PI;
        
        window.dic_spawn_object[send_key] = obj;
        obj.send_key = send_key;
        //位置設定ui付与
        window.setup_tr_con(obj);

      };
      
      window.prepare_receive_fbx = (id,filesize,send_key,receive_key,motion_name) =>{
        let info = {filesize:filesize,buffers:[],amount:0};
        window.dic_file_receive_handler[receive_key] = async (evt) =>{
          let data = evt.data;
          let target = id;
          let amount = info.amount;
          info.buffers.push(data);
          let sz = data.byteLength;
          amount+=sz;
          info.amount = amount;
          if(amount >= info.filesize){
            //受信完了したのでアニメーション登録
            let fulldata = joinArrayBuffer(info.buffers);
            await addMotion(motion_name,fulldata);
          }else{
          }
        }
      }

      window.uploadFbx = async (file_upload) =>{
        let filename = file_upload.files[0].name;
        let motion_name = await promptAsync("モーション名",{default_value:filename});
        if(!motion_name){
          return;
        }
        if(motion_name in ANIMATION_MAP){
          await alertAsync("モーション名が既存と重複");
          return;
        }


        await window.upload_resource(file_upload,async (data)=>{
          let send_key = window.make_file_send_key();
          //自分の空間は先に設定
          window.addMotion(motion_name,data);
          let filesize = data.byteLength;
          window.dic_file_send_data[send_key] = data;
          let res = {
            action:"req_send_fbx",
            send_key:send_key,
            filesize:filesize,
            motion_name:motion_name,
          };
          p2p_client.broadcast("command",JSON.stringify(res));
        });
      }

      //新参から聞かれた場合用のモーションキャッシュ
      window.dic_motion_data = {};
      //未知のモーションが来た場合に取得後に再生するための
      //モーション名->idの辞書
      window.dic_wished_motion={};
      window.addMotion = async (motion_name,data) =>{
        //自身と既存アバター全部に追加が必要
        if(motion_name in ANIMATION_MAP){
          //破壊防止
          return;
        }
        window.dic_motion_data[motion_name] = data;
        await addAnimation2AvatarFromArrayBuffer(window._avatar,motion_name,data);
        for(let id in dic_player){
          let avatar = dic_player[id].avatar;
          await addAnimation2AvatarFromArrayBuffer(avatar,motion_name,data);
          if(motion_name in window.dic_wished_motion){
            if(window.dic_wished_motion[motion_name]==id){
              avatar.stopClip();
              avatar.playClipOnce(motion_name);
              delete window.dic_wished_motion[motion_name];
            }
          }
          
        }
        ANIMATION_MAP[motion_name] = motion_name;
        dic_ANIMATION_NAME[motion_name]=motion_name;
        //追加モーションは非ループ
        dic_nonloop_animation[motion_name] = 1;
        
        //ui回りなのでここでやるのは本当は微妙
        const select = document.querySelector("#animations");
        const option = document.createElement("option");
        option.value = motion_name;
        option.textContent = motion_name;
        select.appendChild(option);
      };

      //spotlightはファイル転送を伴わないので単に表示要求
      window.uploadSpotLight = async () =>{
        let send_key = window.make_file_send_key();
        window.local_show_spotlight(send_key);
        let res = {
          action:"req_show_spotlight",
          send_key:send_key,
        };
        p2p_client.broadcast("command",JSON.stringify(res));
      }

      window.local_show_spotlight = async (send_key) =>{
        window.showSpotLight(window.myplayer,send_key);
      }
      window.rpc_show_spotlight = async (id,send_key) =>{
        if(id in dic_player){
          window.showSpotLight(dic_player[id],send_key);
        }
      };

      window.showSpotLight = async (base_obj,send_key) =>{

        let obj = new THREE.Mesh(                                     
          new THREE.CylinderGeometry(0.2,0.5,0.8,12),                         
          new THREE.MeshPhongMaterial({                                      
          color: 0x00FF7F
        }));
        let spotlight = new THREE.SpotLight(0xFFFFFF, 4, 30, Math.PI / 4, 10, 0.5);

        //todo なぜか影を有効にするとシェーダエラーが発生する
        //three-vrmのfragmentシェーダでvSpotShadowCoord これが未定義のためなんだが
        //仕方が無いのでシェーダを書き換えたmoduleをローカルにおいている
        //threeのr153だと動かない。r154指定。
        
        spotlight.castShadow = true;
        spotlight.shadow.mapSize.width = 1024;
        spotlight.shadow.mapSize.height = 1024;
        spotlight.shadow.camera.near = 0.5;
        spotlight.shadow.camera.far = 4000;

        obj.add(spotlight);
        let spotlight_target = new THREE.Object3D();
        obj.add(spotlight_target);
        spotlight_target.position.set(0,-100,0);
        spotlight.target = spotlight_target;

        the_scene.add(obj);
        obj.position.set(base_obj.position.x,base_obj.position.y,base_obj.position.z);
        obj.rotation.y = base_obj.rotation.y + Math.PI;

        window.dic_spawn_object[send_key] = obj;
        obj.send_key = send_key;
        obj.spotlight=spotlight;
        //位置設定ui付与
        window.setup_tr_con(obj);

      };


      window.prepare_receive_video = (id,filesize,send_key,receive_key) =>{
        let info = {filesize:filesize,buffers:[],amount:0};
        window.dic_file_receive_handler[receive_key] = async (evt) =>{
          let data = evt.data;
          let target = id;
          let amount = info.amount;
          info.buffers.push(data);
          let sz = data.byteLength;
          amount+=sz;
          info.amount = amount;
          if(amount >= info.filesize){
            //受信完了したので結合して対象プレイヤーの位置に表示
            let fulldata = joinArrayBuffer(info.buffers);
            await rpc_show_video(id,fulldata,send_key);
          }else{
          }
        }
      }
      window.local_show_video = async (data,send_key) =>{
        window.showVideo(window.myplayer,data,send_key);
      }
      window.rpc_show_video = async (id,data,send_key) =>{
        if(id in dic_player){
          window.showVideo(dic_player[id],data,send_key);
        }
      };
      window.uploadVideo = async (file_upload) =>{
        await window.upload_resource(file_upload,async (data)=>{
          let send_key = window.make_file_send_key();
          window.local_show_video(data,send_key);
          let filesize = data.byteLength;
          window.dic_file_send_data[send_key] = data;
          let res = {
            action:"req_send_video",
            send_key:send_key,
            filesize:filesize,
          };
          p2p_client.broadcast("command",JSON.stringify(res));
        });
      }


      window.showVideo = async (base_obj,data,send_key) =>{
        var video = _createElement('video');
        video.muted = true;
        video.volume= 0;
        video.loop = true;
        video.preload = 'metadata'


    
        //メタデータロード後じゃないとサイズ取れない
        const callback = (e) =>{

          var tex = new THREE.VideoTexture( video );
          tex.minFilter = THREE.LinearFilter;
          tex.magFilter = THREE.LinearFilter;
          
          const org_w = video.videoWidth;
          const org_h = video.videoHeight;
          
          //これだめ
          //tex.format = THREE.RGBFormat;
          tex.encoding = THREE.sRGBEncoding
          
          const h = 2;
          const w = org_w / (org_h/h);

          // 平面
          const geometry = new THREE.PlaneGeometry(w, h);
          //const material = new THREE.MeshPhongMaterial( { map:tex ,side:THREE.DoubleSide} );
          const material = new THREE.MeshBasicMaterial({ map: tex });
          const plane = new THREE.Mesh( geometry, material );


          //裏から認識したいので２面作る
          const material2 = new THREE.MeshBasicMaterial({ color: 0xf8ddb7 });
          const plane2 = new THREE.Mesh( geometry, material2 );
          

          const obj = new THREE.Object3D();
          obj.add(plane);
          obj.add(plane2);


          //入れ子にして底辺をy=0にする
          plane.position.y = h/2;
          plane2.position.y = h/2;
          plane2.position.z = -0.01;
          plane2.rotation.y = Math.PI;
          the_scene.add(obj);
          obj.position.set(base_obj.position.x,base_obj.position.y,base_obj.position.z);
          obj.rotation.y = base_obj.rotation.y + Math.PI;
          window.dic_spawn_object[send_key] = obj;
          obj.send_key = send_key;
          obj.video=video;



          //位置設定ui付与
          window.setup_tr_con(obj);
        };
        

        const blob = new Blob([data]);
        let url =  window.URL.createObjectURL(blob);
        if(video.onloadedmetadata){
          video.onloadedmetadata = callback;
        }else{
          //chrome
          video.addEventListener('loadedmetadata', callback);
        }
        video.src = url;
        video.load();
        video.play();
        var vc = document.getElementById('video-container');
        vc.appendChild(video);
      };



      window.prepare_receive_audio = (id,filesize,send_key,receive_key) =>{
        let info = {filesize:filesize,buffers:[],amount:0};
        window.dic_file_receive_handler[receive_key] = async (evt) =>{
          let data = evt.data;
          let target = id;
          let amount = info.amount;
          info.buffers.push(data);
          let sz = data.byteLength;
          amount+=sz;
          info.amount = amount;
          if(amount >= info.filesize){
            //受信完了したので結合して対象プレイヤーの位置に表示
            let fulldata = joinArrayBuffer(info.buffers);
            await rpc_show_audio(id,fulldata,send_key);
          }else{
          }
        }
      }
      window.local_show_audio = async (data,send_key) =>{
        window.showAudio(window.myplayer,data,send_key);
      }
      window.rpc_show_audio = async (id,data,send_key) =>{
        if(id in dic_player){
          window.showAudio(dic_player[id],data,send_key);
        }
      };
      window.uploadAudio = async (file_upload) =>{
        await window.upload_resource(file_upload,async (data)=>{
          let send_key = window.make_file_send_key();
          window.local_show_audio(data,send_key);
          let filesize = data.byteLength;
          window.dic_file_send_data[send_key] = data;
          let res = {
            action:"req_send_audio",
            send_key:send_key,
            filesize:filesize,
          };
          p2p_client.broadcast("command",JSON.stringify(res));
        });
      }


      window.showAudio = async (base_obj,data,send_key) =>{
        
        const audio = new THREE.PositionalAudio(window.mylistener);
        const refDis = 10; // 音量が下がり始める距離
        const rolloff = 2; // 音源から遠ざかった時にどのくらいすぐに音量が下がるか
        const volume = 1;

        audio.autoplay = true;

        window.AudioContext = window.AudioContext || window.webkitAudioContext;
        const context = new AudioContext();
        // ArrayBufferからAudioBufferに変換
        const ArrayBuffer = data.slice(0);
        const audioBuffer = await (new Promise((res, rej) => {
          context.decodeAudioData(ArrayBuffer, res, rej);
        }));
        audio.setBuffer(audioBuffer);
        audio.setRefDistance(refDis);
        audio.setLoop(true);
        audio.setRolloffFactor(rolloff);
        audio.setVolume(volume);

        let _spk = await loadModel('asset/model/speaker.glb');
        const spk = _spk.scene;
        const obj = new THREE.Object3D();
        obj.add(spk);
        spk.scale.set(1,1,1);
        spk.position.set(0,0,0);
        spk.rotation.set(0,0,0);
        spk.traverse(
          (object) => { //モデルの構成要素
            if(object.isMesh) { //その構成要素がメッシュだったら
              object.castShadow = true;//影表示
              object.material.metalness = 0;//これしないと暗くなる
            }
          }
        );
        obj.add(audio);
        the_scene.add(obj);
        obj.position.set(base_obj.position.x,base_obj.position.y,base_obj.position.z);
        obj.rotation.y = base_obj.rotation.y + Math.PI;

        //再生中揺らす
        let clip = AnimationClipCreator.CreateShakeAnimation(1,new THREE.Vector3(0,0.1,0));
        let mixer = new THREE.AnimationMixer( obj );
        let clipAction = mixer.clipAction( clip );
        let fn_anim = (dt)=>{
          if(send_key in window.dic_spawn_object){
            mixer.update(dt);
          }else{
            //ここで削除したいんだが
            //window.animation_ticksを再構成すると
            //そのあとのロードで再生されなくなるので
            //空関数と差し替える
            let n = window.animation_ticks.length;
            for(let i=0;i<n;i++){
              let tf = window.animation_ticks[i];
              if(tf === fn_anim){
                window.animation_ticks[i] = ()=>{};
              }
            }
          }
        };
        window.animation_ticks.push(fn_anim);
        obj.clipAction = clipAction;
        obj.clipAction.play();
          
        window.dic_spawn_object[send_key] = obj;
        obj.send_key = send_key;
        obj.audio=audio;
        //位置設定ui付与
        window.setup_tr_con(obj);
        
      };



      window.prepare_receive_glb = (id,filesize,send_key,receive_key) =>{
        let info = {filesize:filesize,buffers:[],amount:0};
        window.dic_file_receive_handler[receive_key] = async (evt) =>{
          let data = evt.data;
          let target = id;
          let amount = info.amount;
          info.buffers.push(data);
          let sz = data.byteLength;
          amount+=sz;
          info.amount = amount;
          if(amount >= info.filesize){
            //受信完了したので結合して対象プレイヤーの位置に表示
            let fulldata = joinArrayBuffer(info.buffers);
            await rpc_show_glb(id,fulldata,send_key);
          }else{
          }
        }
      }
      window.local_show_glb = async (data,send_key) =>{
        window.showGlb(window.myplayer,data,send_key);
      }
      window.rpc_show_glb = async (id,data,send_key) =>{
        if(id in dic_player){
          window.showGlb(dic_player[id],data,send_key);
        }
      };
      window.uploadGlb = async (file_upload) =>{
        await window.upload_resource(file_upload,async (data)=>{
          let send_key = window.make_file_send_key();
          window.local_show_glb(data,send_key);
          let filesize = data.byteLength;
          window.dic_file_send_data[send_key] = data;
          let res = {
            action:"req_send_glb",
            send_key:send_key,
            filesize:filesize,
          };
          
          p2p_client.broadcast("command",JSON.stringify(res));
          console.log("send command ",res);
        });
      }

      
      window.animation_ticks = [];
      window.showGlb = async (base_obj,data,send_key) =>{
        let glb = await loadModelFromArrayBuffer(data);

        const obj = glb.scene;
        obj.send_key = send_key;
        const animations = glb.animations;
        if(animations && animations.length) {
          
          //Animation Mixerインスタンスを生成
          let mixer = new THREE.AnimationMixer(obj);

          //全てのAnimation Clipに対して
          for (let i = 0; i < animations.length; i++) {
              let animation = animations[i];

              //Animation Actionを生成
              let action = mixer.clipAction(animation) ;

              //ループ設定（1回のみ）
              //action.setLoop(THREE.LoopOnce);

              //アニメーションの最後のフレームでアニメーションが終了
              action.clampWhenFinished = true;

              //アニメーションを再生
              action.play();
          }
        
          let anifn = function(dt){
            if(send_key in window.dic_spawn_object){
              //console.log("play "+name);
              mixer.update(dt);
            }else{
              let n = window.animation_ticks.length;
              for(let i=0;i<n;i++){
                let tf = window.animation_ticks[i];
                if(tf === fn_anim){
                  window.animation_ticks[i] = ()=>{};
                }
              }
            }
          }
          window.animation_ticks.push(anifn);
        }      
        obj.traverse(
          (object) => { //モデルの構成要素
            if(object.isMesh) { //その構成要素がメッシュだったら
              object.castShadow = true;//影表示
              object.material.metalness = 0;//これしないと暗くなる
            }
          }
        );
        the_scene.add(obj);
        obj.position.set(base_obj.position.x,base_obj.position.y,base_obj.position.z);
        obj.rotation.y = base_obj.rotation.y + Math.PI;
        
        window.dic_spawn_object[send_key] = obj;
        obj.send_key = send_key;
        //位置設定ui付与
        window.setup_tr_con(obj);

      };



      window.prepare_receive_avatar = (id,filesize,send_key,receive_key) =>{
        let info = {filesize:filesize,buffers:[],amount:0};
        window.dic_file_receive_handler[receive_key] = async (evt) =>{
          let data = evt.data;
          let amount = info.amount;
          info.buffers.push(data);
          let sz = data.byteLength;
          amount+=sz;
          //console.log(receive_key,evt,amount);
          info.amount = amount;
          if(amount >= info.filesize){
            //受信完了したので結合してotherのアバター更新
            let fulldata = joinArrayBuffer(info.buffers);
            let avatar =  await loadVrmAsAvatarFromArrayBuffer(fulldata,id);
            await rpc_avatar_avatar(id,avatar);
          }else{
          }
        }
      }
      window.rpc_avatar_avatar = async (id,avatar) =>{
        if(id in dic_player){
          let obj = dic_player[id];
          obj.remove(obj.avatar._object3D);
          obj.add(avatar._object3D);
          obj.avatar = avatar;
          obj.avatar_idx = 0;
        }else{
          //まだjoinしていない？
          
        }
      }
      window.check_last_avatar = async () =>{
        //部屋移動時にもし移動前にアバターを設定していたら継承する
        if("last_avatar" in window.parent){
          //そのまま引き継ぐとarraybuffer認定してもらえない
          const _data = window.parent.last_avatar;
          var data = new ArrayBuffer(_data.byteLength);
          new Uint8Array(data).set(new Uint8Array(_data));

          window.buff_local_avatar = data;
          //先にアバターチェンジ
          window.last_model_url = data;
          let send_key = window.make_file_send_key();
          window.dic_file_send_data[send_key] = data;
          await changeAvatar(data, ANIMATION_MAP);
          window.setupAvatar(window._avatar);
          //req_send_avatarをブロードキャストする
          //プレイヤーがいる場合だけ
          if(dic_player.length>0){
            let req = {
              action:"req_send_avatar",
              filesize:data.byteLength,
              send_key:send_key,
            }
            p2p_client.broadcast("command",JSON.stringify(req));
          }
        }
      }
      
      window.upload_avatar = async (file_upload) =>{
        console.log("upload_avatar called ");
        await upload_resource(file_upload,async (data)=>{
          window.buff_local_avatar = data;
          //先にアバターチェンジ
          window.last_model_url = data;
          let send_key = window.make_file_send_key();
          window.dic_file_send_data[send_key] = data;
          window.parent.last_avatar = data
          await changeAvatar(data, ANIMATION_MAP);
          window.setupAvatar(window._avatar);
          //req_send_avatarをブロードキャストする
          let req = {
            action:"req_send_avatar",
            filesize:data.byteLength,
            send_key:send_key,
          }
          p2p_client.broadcast("command",JSON.stringify(req));
        });
      };
      window.rpc_avatar = async (id,idx) =>{
        if(id in dic_player){
          let obj = dic_player[id];
          if(obj.avatar_idx==idx){
            return;
          }
          let avatar = await loadVrmAsAvatar(AVATARS[idx],id);
          obj.remove(obj.avatar._object3D);
          obj.add(avatar._object3D);
          obj.avatar = avatar;
          obj.avatar_idx = idx;
        }else{
          dic_player_avatar[id]=idx;
        }
      }
      window.cmd_avatar = (idx) =>{
        //window.changeAvatar(idx);
        
        //ファイルで上げたの消す
        window.buff_local_avatar = null;

        let buffer = new ArrayBuffer(2+2);
        var view = new DataView(buffer);
        view.setUint16(0,RPC_AVATAR);
        view.setUint16(2,idx);
        p2p_client.broadcast("rpc",buffer);
      };
      window.cmd_avatar_partial = (id,idx) =>{
        //window.changeAvatar(idx);
        let buffer = new ArrayBuffer(2+2);
        var view = new DataView(buffer);
        view.setUint16(0,RPC_AVATAR);
        view.setUint16(2,idx);
        p2p_client.send(id,"rpc",buffer);
      };

      const walk_speed =2;
      const rot_speed = Math.PI/2; 
      let vec_walk = new THREE.Vector3();
      let prev_pos = {x:0,y:0,z:0};
      let prev_rot = {x:0,y:0,z:0};
      let last_send  =0;
      
      //other person処理
      //メインのtickの中から呼ぶ
      window.tick_others= (dt) =>{
        //自分の位置が前フレームと違っていたら
        //同期送信する
        let ts = Date.now();
        
        
        for(let anfn of window.animation_ticks){
          anfn(dt);
        }
        
        if("myplayer" in window){
          let pos = window.myplayer.position;
          let rot = window.myplayer.rotation;
          let no_change = (pos.x == prev_pos.x) 
            && (pos.y == prev_pos.y)
            && (pos.z == prev_pos.z)
            && (rot.x == prev_rot.x) 
            && (rot.y == prev_rot.y)
            && (rot.z == prev_rot.z);
          //負荷を抑えるために100ms間隔での位置同期
          if(!no_change && ts-last_send > 100){
            if("req_sync_player" in window){
              last_send = ts;
              window.req_sync_player();
              prev_pos.x = pos.x;
              prev_pos.y = pos.y;
              prev_pos.z = pos.z;
              prev_rot.x = rot.x;
              prev_rot.y = rot.y;
              prev_rot.z = rot.z;
            };
          }
        }

        //リモート
        for(let id in dic_player){
          let other = dic_player[id];
          if("wish_pos" in other){
            //補間計算
            let wish_pos = other.wish_pos;
            let cur_pos = other.position;
            vec_walk.set(wish_pos.x - cur_pos.x,wish_pos.y - cur_pos.y , wish_pos.z - cur_pos.z);
            let org_dist = vec_walk.length();
            vec_walk.normalize();
            vec_walk.multiplyScalar(walk_speed);
            vec_walk.multiplyScalar(dt);
            let alt_dist = vec_walk.length();
            if(alt_dist > org_dist){
              other.position.set(wish_pos.x,wish_pos.y,wish_pos.z);
            }else{
              other.position.add(vec_walk);
            }
            
          }else if(dic_player_transform[id]){
            let wish_pos = dic_player_transform[id].position;
            other.position.set(wish_pos.x,wish_pos.y,wish_pos.z);
          };
          if("wish_rot" in other){
            //補間計算
            let wish_rot = other.wish_rot.y;
            let cur_rot = other.rotation.y;
            let org_diff = wish_rot - cur_rot;
            let org_abs_diff= Math.abs(org_diff);
            let alt_diff = ((org_diff>0)?1:-1)*rot_speed*dt;
            let alt_abs_diff= Math.abs(alt_diff);
            if(alt_abs_diff>org_abs_diff){
              other.rotation.y = wish_rot;
            }else{
              other.rotation.y += alt_diff;
            }
            
          }else if(dic_player_transform[id]){
            let wish_rot = dic_player_transform[id].rotation;
            other.rotation.y = wish_rot.y;
          }
          other.avatar.tick(dt);
        }
      }
      
      window.req_names = () =>{
        const res = {
          mode:"req_names",
        };
        window.parent.sig_p2p_client.send(window.parent.host_id,"signaling",JSON.stringify(res));
      };
      window.dic_id2name = {};
      window.join_player =  async (id) =>{
        let idx = 0;
        if(id in dic_player_avatar){
          idx = dic_player_avatar[id];
        }
        let avatar = await loadVrmAsAvatar(AVATARS[idx],id);
        const obj = new THREE.Object3D("otherPerson");
        obj.add(avatar._object3D);
        obj.avatar = avatar;
        dic_player[id] = obj;
        let pname = "";
        if(id in window.dic_id2name){
          //既知
          pname = window.dic_id2name[id];
        }else{
          //ホストに名前聞く
          window.req_names();
        }
        
        window.rpc_set_name(id,pname);//初期設定
        window.the_scene.add(obj);
        
        //名前を聞く
        //host-clientモードではホストに聞く
        /*
        let res = {
          action:"req_your_name",
        };
        p2p_client.send(id,"command",JSON.stringify(res));
        */
      }
      
      window.set_my_name = (name) =>{
        window.my_name = name;
        document.getElementById("spn_my_name").textContent = name;
        let res = {
          action:"my_name_is",
          name:window.my_name
        };
        p2p_client.broadcast("command",JSON.stringify(res));
      };

      window.leave_player =  async (id) =>{
        if(id in dic_player){
          let other = dic_player[id];
          window.the_scene.remove(other);
          delete dic_player[id];
        }
      }


      
      var textOut = document.getElementById("text-out");
      window.add_goto_button = (sender,dist) =>{
        //指定ページへの移動ボタンをログに出す
        const line = _createElement("li");
        let sender_nickname = "あなた";
        if(sender in dic_player){
          //他人の発言
          if("player_name" in dic_player[sender]){
            sender_nickname = dic_player[sender].player_name;
          }else{
            sender_nickname= "名無し";
          }
          line.className= "log_other";
        }else if(sender==""){
          //システム
          sender_nickname= "マスター";
          line.className= "log_system";
        }else{
          //自分の発言
          sender_nickname= "あなた";
          line.className= "log_self";
        }
        line.innerHTML = `${sender_nickname}:`;
        const btn = document.createElement("button");
        btn.type="button";
        btn.innerHTML="部屋移動";
        btn.style="pointer-events:all;"
        btn.onclick= async () =>{
          let flg = await confirmAsync(dist+"への移動を実行しますか？移動するとログは失われます。");
          if(flg){
            location.href = dist+"?"+Date.now();
          }
        };
        line.appendChild(btn);
        textOut.appendChild(line);
        line.scrollIntoView();
      }
      window.add_chat_log = (sender,target,chat,is_tell=false) =>{
        const line = _createElement("li");
        let sender_nickname = "名無し";
        if(sender){
          //他人の発言
          if(sender in dic_player){
            if("player_name" in dic_player[sender]){
              sender_nickname = dic_player[sender].player_name;
            }
            if(!sender_nickname){
              sender_nickname = "名無し";
            }
          }
          if(is_tell){
            line.className= "log_tell";
          }else{
            line.className= "log_other";
          }
        }else{
          //自分の発言
          sender_nickname= "あなた";
          line.className= "log_self";
        }
        if(target){
          let target_nickname = "名無し";
          //この場合、自分から他人へのtell
          if(target in dic_player){
            if("player_name" in dic_player[target]){
              target_nickname = dic_player[target].player_name;
            }
            if(!target_nickname){
              target_nickname = "名無し";
            }
          }
          line.innerHTML = `${sender_nickname}>>${target_nickname}:${chat}`;
        }else{
          line.innerHTML = `${sender_nickname}:${chat}`;
        }
        
        textOut.appendChild(line);
        line.scrollIntoView();
      } 
      window.add_system_log = (message) =>{
        const line = _createElement("li");
        line.textContent=message;
        line.className= "log_system";
        textOut.appendChild(line);
        line.scrollIntoView();
      } 

      window.setupFreeCamera = (scene,camera) =>{
        //メインカメラとレンダラーはverse_setupdの前に定義済みなのでここではフリーカメラの初期化
        const camera2 = new THREE.PerspectiveCamera(
          60,
          window.innerWidth / window.innerHeight,
          0.1,
          100
        );
        scene.add(camera2);
        window._freeCamera = camera2;
        window._freeCameraControlls = new OrbitControls( window._freeCamera, window.the_renderer.domElement );
        window._freeCameraControlls.enableDamping = true;
        window._freeCameraControlls.dampingFactor = 0.2;
        window._freeCameraControlls.enabled=false;

        camera2.position.set(0, 1.6, 0);
        window._useFreeCamera = false;
        window.addEventListener("resize", () => {
          if(window._freeCamera){
            window._freeCamera.aspect = window.innerWidth / window.innerHeight;
            window._freeCamera.updateProjectionMatrix();
          }      
          window.the_renderer.setSize(window.innerWidth, window.innerHeight);
          window.labelRenderer.setSize(window.innerWidth, window.innerHeight);
        });
      }

      window.onRender = (dt)=>{
        if(window._useFreeCamera){
          window._freeCameraControlls.update();//カメラコントローラの移動処理
          window.the_renderer.render(the_scene, window._freeCamera);
          window.labelRenderer.render(the_scene, window._freeCamera);
        }else{
          the_renderer.render(the_scene, mycamera);
          labelRenderer.render(the_scene, mycamera);
        }
      };

      //自由視点モード
      window.set_freecam = () =>{
        if(window.current_tr_con){
          return;
        }
        //tpsモード前提
        const ui_fps = document.getElementById("fps");
        if(ui_fps.checked){
          return;
        }

        if(!window._freeCamera){
          window.setupFreeCamera(window.the_scene,window.mycamera);
        }
        window.the_playerController.moveController.enabled = false;
        window.the_playerController.touchController.enabled = false;
        let pos = window._avatar.object3D.getWorldPosition(new THREE.Vector3());
        let head_pos = window._avatar.object3D.getWorldPosition(new THREE.Vector3());
        let fwd = window._avatar.object3D.getWorldDirection(new THREE.Vector3());
        let up = new THREE.Vector3(0,1,0);
        let up_rate = 2;
        let fwd_rate = 2;
        pos.x = pos.x + fwd.x * fwd_rate + up.x * up_rate;
        pos.y = pos.y + fwd.y * fwd_rate + up.y * up_rate;
        pos.z = pos.z + fwd.z * fwd_rate + up.z * up_rate;
        head_pos.x = head_pos.x + up.x ;
        head_pos.y = head_pos.y + up.y ;
        head_pos.z = head_pos.z + up.z ;
        window._freeCamera.position.set(pos.x,pos.y,pos.z);
        window._freeCameraControlls.target = head_pos;
        window._freeCameraControlls.enabled=true;
        window._freeCameraControlls.update();
        window._freeCameraControlls.saveState()
        window.the_playerController.xrController._pointerControllerL._camera=window._freeCamera;
        window.the_playerController.xrController._pointerControllerR._camera=window._freeCamera;
        window._useFreeCamera = true;
      };

      //自由視点モード解除
      window.unset_freecam = () =>{
        if(window.current_tr_con){
          return;
        }


        window.the_playerController.moveController.enabled = true;
        window.the_playerController.touchController.enabled = true;
        window._freeCameraControlls.enabled = false;
        window.the_playerController.xrController._pointerControllerL._camera=window.mycamera;
        window.the_playerController.xrController._pointerControllerR._camera=window.mycamera;
        window._useFreeCamera = false;

      };



      const setupGUI= (ctx) => {
        const tgl_camera = document.getElementById("tgl_camera");
        tgl_camera.onclick = () =>{
          if(window._useFreeCamera){
            window.unset_freecam();
            tgl_camera.value=">>撮影モード";
          }else{
            window.set_freecam();
            tgl_camera.value=">>移動モード";
          }
        };
        
        const onSelect = (el, cb) => {
          el.addEventListener("change", (e) => {
            cb(e.target.value);
          });
        };
        const onCheck = (el, cb) => {
          el.addEventListener("change", (e) => {
            cb(e.target.checked);
          });
        };
        //デフォルトアバターからの選択
        {
          const select = document.querySelector("#avatars");
          onSelect(select, (v) => {
            document.querySelector("#animations").value = "idle";
            changeAvatar(v, ANIMATION_MAP);
            if(window.cmd_avatar){
              let idx = select.selectedIndex;
              window.cmd_avatar(idx);
            }
          });
          for (const v of AVATARS) {
            const a = v.split("/");
            const o = document.createElement("option");
            o.value = v;
            o.innerText = a[a.length - 1];
            select.appendChild(o);
          }
        }
        
        //アバターアップロード
        document.getElementById("vrm_upload").onchange = () =>{
          window.upload_avatar(document.getElementById("vrm_upload"));
        };
        
        //画像アップロード
        document.getElementById("image_upload").onchange = async () =>{
          const upload_ui = document.getElementById("image_upload");
          let filename = upload_ui.value;
          if(!filename){
            return;
          };
          let arr = filename.split(".");
          let ext = arr.pop().toLowerCase();
          if(ext=="ply"){
            window.uploadPly(upload_ui);
          }else if(ext=="fbx"){
            window.uploadFbx(upload_ui);
          }else if(ext=="glb"){
            window.uploadGlb(upload_ui);
          }else if(ext=="mp3" ){
            window.uploadAudio(upload_ui);
          }else if(ext=="mp4" || ext=="webm" || ext=="mov"){
            window.uploadVideo(upload_ui);

          }else if(ext=="png" || ext=="jpg" || ext=="jpeg"){
            window.uploadImage(upload_ui);
          }else{
            await alertAsync("非対応形式ファイル");
          }
          
        };
        
        //名前設定
        document.getElementById("btn_name").onclick = async ()=>{
          if(!window.my_name){
            window.my_name = "";
          }
          let old_name = window.my_name;
          let name = await promptAsync("名前",{default_value:old_name,placeholder:"名前"});
          if(name){
            window.set_my_name(name);
          }
        };
        
        window.proc_tell_input =  async (id) =>{
          if(id in dic_player){
            const to_name  = dic_player[id].player_name;
            const tell = await promptAsync("["+to_name+"]への対話");
            if(tell){
              window.tell_chat(id,tell);
            }
          }
        };
        

        window.getTimeStr=(d=null)=> {
          if(!d){
            var d = new Date();
          }
          var yyyy = d.getUTCFullYear();
          var MM = ('0' + (d.getUTCMonth() + 1)).slice(-2);
          var dd = ('0' + d.getUTCDate()).slice(-2);
          var hh = ('0' + d.getUTCHours()).slice(-2);
          var mm = ('0' + d.getUTCMinutes()).slice(-2);
          var ss = ('0' + d.getUTCSeconds()).slice(-2);
          return yyyy + '' + MM + '' + dd + '_' + hh + '' + mm ;
        }

        window.saveChatLog = () => {
          const textOut= document.getElementById("text-out");
          let filename = "chatlog_"+getTimeStr()+".html";
          let text = "";
          let style = "<style>#text-out {height: 3rem;color:black;text-shadow:1px 1px 0 #FFF, -1px -1px 0 #FFF,-1px 1px 0 #FFF, 1px -1px 0 #FFF,0px 1px 0 #FFF,  0-1px 0 #FFF,-1px 0 0 #FFF, 1px 0 0 #FFF;}</style>";
          text += "<html><head></head><body>";
          text += style;
          text += textOut.outerHTML;
          text += "</body></html>";
          const blob = new Blob([text], { type: 'text/plane' });
          const aTag = _createElement('a');
          aTag.href = URL.createObjectURL(blob);
          aTag.target = '_blank';
          aTag.download = filename;
          aTag.click();
          URL.revokeObjectURL(aTag.href);
        };



        //発言
        const proc_say_input = () =>{
          let chat = chat_input.value;
          if(chat){
            let is_system=false;
            if(chat.toLowerCase().indexOf("dice:")===0){
              let p = chat.toLowerCase();
              let arr = p.split(":");
              let _arr = arr[1].split("d");
              if(_arr.length>1){
                let number = _arr[0];
                let size = _arr[1];
                if(Number.isInteger(number*1) && Number.isInteger(size*1)){
                  p2p_client.requestDice(number,size);
                  is_system = true;
                }
              }
            }else if(chat.toLowerCase().indexOf("call:")===0){
              //gmコール
              let msg = chat.substring(5);
              let cmd = {
                mode:"call",
                sender:window.my_id,
                chat:msg,
              };
              window.p2p_client.signaling.send(JSON.stringify(cmd));
              window.add_system_log("あなた>>マスター:"+msg);
              is_system = true;
            }else if(chat.toLowerCase().indexOf("goto:")===0){
              let dist = chat.substring(5);
              let cmd = {
                action:"goto",
                sender:window.my_id,
                dist:dist,
              };
              window.p2p_client.broadcast("command",JSON.stringify(cmd));
              window.add_goto_button(window.my_id,dist);
              is_system = true;
            }else if(chat.toLowerCase().indexOf("reload:")===0){
              if(confirm("再読み込みしますか？")){
                location.reload();
              }
              is_system = true;

            }else if(chat.toLowerCase().indexOf("save_log:")===0){
              window.saveChatLog();
              is_system = true;

            }else if(chat.toLowerCase().indexOf("spotlight:")===0){
              window.uploadSpotLight();
              is_system = true;

            }

            if(is_system){
              //システムコマンド
              chat_input.value="";
            }else{
              window.say_chat(chat);
              chat_input.value="";
            }
          
          }
        }
        var chat_input = document.getElementById("chat_input");
        chat_input.addEventListener('keydown', e => {
          if (e.isComposing || e.key === 'Process' || e.keyCode === 229) {
             // IME入力中
          } else {
            if(e.keyCode==13){
              proc_say_input();
            }
          }
        });
        document.getElementById("btn_say").onclick = async ()=>{
          proc_say_input();
        };



        
        //ログ切り替え
        var log_visible = true;
        var log_state = 1;// 0 非表示 1 通常 2 全幅
        var chat_log = document.getElementById("chat-log");
        document.getElementById("btn_log").onclick = async ()=>{
          if(log_state == 0){
            chat_log.style.width="330px";
            chat_log.style.display="";
            log_state=1;
          }else if(log_state==1){
            chat_log.style.width="100vw";
            chat_log.style.display="";
            log_state=2;
          }else if(log_state==2){
            chat_log.style.display="none";
            log_state=0;
          }else{
            chat_log.style.width="330px";
            chat_log.style.display="";
            log_state=1;
          }
        };


        //モーション同期
        {
          const btn_emote = document.querySelector("#btn_emote");
          btn_emote.onclick = async () =>{
            //dic_ANIMATION_NAMEから候補を作る
            let buttons = [];
            for(let mo in dic_ANIMATION_NAME){
              let btn = {};
              btn.caption = dic_ANIMATION_NAME[mo];
              btn.value = mo;
              buttons.push(btn);
            }
            let param = {buttons:buttons};
            let v = await choiceAsync("所作",param);
            if(v){
              let res = {
                action:"emote",
                motion:v,
              };
              p2p_client.broadcast("command",JSON.stringify(res));
              window._avatar.stopClip();
              if(v in dic_nonloop_animation){
                window._avatar.playClipOnce(v);
              }else{
                window._avatar.playClip(v);
              }
            }
          }

          const select = document.querySelector("#animations");
          onSelect(select, (v) =>{
            let res = {
              action:"emote",
              motion:v,
            };
            p2p_client.broadcast("command",JSON.stringify(res));
            window._avatar.stopClip();
            if(v in dic_nonloop_animation){
              window._avatar.playClipOnce(v);
            }else{
              window._avatar.playClip(v);
            }
          });
          for (const v of Object.keys(ANIMATION_MAP)) {
            const o = document.createElement("option");
            o.value = v;
            o.innerText = v;
            select.appendChild(o);
          }
        }
        onCheck(document.querySelector("#lipsync"), ctx.setLipsyncEnabled);
        onCheck(document.querySelector("#ik"), ctx.setTestIKEnabled);
        onCheck(document.querySelector("#lowspec"), ctx.setLowSpecMode);
        onCheck(document.querySelector("#fps"), ctx.setFPSMode);
        onCheck(document.querySelector("#mirror"), ctx.showMirrorHUD);
      }
      
      //公式サンプルのクリック対応はverse-three依存なのでベタに実装
      window.arr_interactive = [];
      const raycaster = new THREE.Raycaster();
      const raycast_vector = new THREE.Vector2();
      const get_interact_object = (evt)=>{
        raycast_vector.x = (evt.clientX / window.innerWidth) * 2 - 1;
        raycast_vector.y = (evt.clientY / window.innerHeight) * -2 + 1;
        raycaster.setFromCamera(raycast_vector, window.mycamera);
        const intersects =   raycaster.intersectObjects(window.arr_interactive);
        //最初のハンドラ持ちだけ返す
        for(let its of intersects ){
          let el = its.object;
          while(! el.onSelectDown){
            if(!el.parent){
              return;
            }
            el = el.parent;
          }
          if (el.onSelectDown) {
            //send_key持ちかつ削除済みは無視
            if("send_key" in el){
              if(!(el.send_key in window.dic_spawn_object)){
                continue;
              }
            }
            return el;
          }
        }
        return null;
      }
      //クリック可能なオブジェクトを積む
      setTimeout(()=>{
        let canvas =  document.getElementsByTagName("canvas")[0];
        let longtap_obj = null;
        let start_x = 0;
        let start_y = 0;
        let drag_limit = 4;//これ以上動いたらドラッグと見なす
        const check_interval = 100;
        const check_count_max = 10;
        let check_count = 0;
        canvas.addEventListener('pointermove', (evt) => {
          if(!longtap_obj){
            cancel_longtap();
            return;
          }
          if(window.tr_draging){
            cancel_longtap();
            return;
          }
          const el = get_interact_object(evt);
          if(el){
            if(el===longtap_obj){
              //まだ保留
            }else{
              //外出たのでキャンセル
              cancel_longtap();
            }
          }else{
            //外出たのでキャンセル
            cancel_longtap();
          }
          
          //開始位置から一定以上動かした場合は
          let cur_x = evt.x;
          let cur_y = evt.y;
          if( (cur_x  - start_x)*(cur_x  - start_x) + (cur_y  - start_y)*(cur_y  - start_y) > drag_limit*drag_limit){
            //キャンセルする
            cancel_longtap();
          }

        });

        canvas.addEventListener('pointerup', (evt) => {
          //離したので解除
          cancel_longtap();
        });
        


        const cancel_longtap = () =>{
          longtap_obj = null;
          check_count=0;
        };
        const check_longtap = () =>{
          if(!longtap_obj){
            cancel_longtap();
            return;
          };
          check_count+=1;
          if(check_count < check_count_max){
            setTimeout(check_longtap,check_interval);
          }else{
            longtap_obj.onSelectDown(longtap_obj);
            cancel_longtap();
          }
        }

        canvas.addEventListener('pointerdown', (evt) => {
          const el = get_interact_object(evt);
          if(el){
            longtap_obj = el;
            start_x = evt.x;
            start_y = evt.y;
            setTimeout(check_longtap,check_interval);
          }else{
            cancel_longtap();
          }
        });
      },1000);
      
      

      window.labelRenderer = new CSS3DRenderer();
      labelRenderer.setSize(window.innerWidth, window.innerHeight);
      labelRenderer.domElement.style.position = "absolute";
      labelRenderer.domElement.style.top = "0px";
      labelRenderer.domElement.style.pointerEvents = "none";
      document.body.appendChild(labelRenderer.domElement);


      export const init = async () =>{
        window.myavatar_idx = 0;
        const ctx = await main(async () => {
          if(window.parent.last_avatar){
            //設定したアバターがあるならそっち採用
            await window.check_last_avatar();
          }else{
            await ctx.changeAvatar(AVATARS[0], ANIMATION_MAP);
            window.setupAvatar(window._avatar);
          }
          
          //キーで移動できない場合があるので
          //何か押したら有効化
          const fn = () =>{
            //オブジェクト編集中は無視
            if(window.current_tr_con){
              return;
            }
            the_playerController.moveController.enabled= true;
            window.parent.the_playerController = the_playerController;
            window.removeEventListener("keydown", fn);
          };
          window.addEventListener("keydown", fn);
          
        });


        window.addEventListener("resize", () => {          
          window.the_renderer.setSize(window.innerWidth, window.innerHeight);
          window.labelRenderer.setSize(window.innerWidth, window.innerHeight);
        });

        window.changeAvatar = ctx.changeAvatar;

        //親ウィンドウのsig_p2p_clientのチャネルでシグナリングする
        callbacks.dc = window.parent.sig_p2p_client.dic_connection[window.parent.host_id].dic_channel["signaling"];
        const p2p_client = new P2P_Client("by_datachannel",callbacks,channels,window.parent.sig_p2p_client.rtc_config);
        window.p2p_client = p2p_client; 
        
        //デバッグ用
        window.parent.the_playerController = the_playerController;
        window.parent.p2p_client = p2p_client;
        window.parent.mycamera = window.mycamera;
        window.parent.myplayer = window.myplayer;
        window.parent.the_scene = window.the_scene;
        window.parent.get_avatar = () =>{return window._avatar};
        setupWater(the_scene,the_renderer,mycamera);
        setupSnow(the_scene,the_renderer,mycamera);

        
        setTimeout(()=>{
          the_playerController.moveController.enabled= true;
          window.parent.the_playerController = the_playerController;
        },3000);

        await createWorldObjects(ctx);
        setupGUI(ctx);
        
        
      };
