import * as THREE from "three";
import { Water } from "three/examples/jsm/objects/Water.js";

export const setupWater = async (
  scene,renderer,camera
)=>  {


  //PlaneGeometry
  const waterGeometry = new THREE.PlaneGeometry(1000,1000);
  
  var use_water = false;
  var water;
  function createWater(wl){
    //Water
    water = new Water(
      waterGeometry,
      {
        textureWidth: 512,
        textureHeight: 512,
        waterNormals: new THREE.TextureLoader().load( 'asset/texture/Water_1_M_Normal.jpg', function(texture){
            texture.wrapS = texture.wrapT = THREE.RepeatWrapping;
        } ),
        alpha: 1.0,
        waterColor: 0x3e89ce,
        distortionScale: 3.7,
        fog:scene.fog !== undefined
      }
    );
    water.position.y=wl;
    window.the_water= water;
    //シーンに追加
    scene.add(water);
    water.rotation.x = - Math.PI / 2;
  }
   
  function rendering(){
    if(!use_water){
      return;
    }
    //アニメーション
    water.material.uniforms['time'].value += 1.0 / 60.0;
    requestAnimationFrame(rendering);
    //renderer.render(scene, camera);
  }
  
  window.play_water = (wl=0.1) =>{
    if(use_water){
      water.position.y=wl;
      return;
    }
    use_water = true;
    createWater(wl);
    rendering();
  }
  
  window.stop_water = ()=>{
    if(!use_water){
      return;
    }
    use_water = false;
    scene.remove(water);
    water.material.dispose();
    water.geometry.dispose();
  }


};
